#!/usr/bin/perl 
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
# Changes and Modifications
# * Thu May 15 03:40:39 CEST 2008       
#       - script created
#

# zabbix path
my $zabbix_sender="/usr/bin/zabbix_sender";
my $zabbix_confd="/etc/zabbix/zabbix_agentd.conf";
my $arrayp="/usr/bin/arrayprobe";
my $zabbix_send_command="$zabbix_sender -c $zabbix_confd";
#my $conf="/home/zabbix/bin/ccissvol_smartmon_sensor_conf";
#my $conf="/usr/lib/zabbix-agent/ccissvol_smartmon_sensor_conf";

# signal handling
$SIG{'ALRM'} = sub {
	local $SIG{TERM} = 'IGNORE';
	kill TERM => -$$;
	print "0\n";
};

local $SIG{TERM} = sub {
	local $SIG{TERM} = 'IGNORE';
	kill TERM => -$$;
	print "0\n";
};

# fetch status from mod_status
alarm 5;
#open FILE, $conf;
#my $disk=<FILE>;
#chomp $disk;
#print $disk;
my $cmd = "sudo $arrayp -f /dev/cciss/c0d0";
my $server_status = qx($cmd);

# get information from status output
alarm 3;
my($health);
$health = $1 if ($server_status =~ /^(\S+)\s+.+/);


#print "kita".$health."\n";


# send information to Zabbix server
alarm 5;
if($health eq "OK"){$health=1;}
else {$health=0;}
if ( qx($zabbix_send_command -k arrayprobe.status -o $health) =~ /failed:\ 1/ ) { print"0\n"; exit(-1);}

print "1\n";
exit(0);
# EOF


